## GstBin GstBin — Base class and element that can contain other elements |

## Functions

GstElement * | gst_bin_new ()
gboolean | gst_bin_add ()
gboolean | gst_bin_remove ()
GstElement * | gst_bin_get_by_name ()
GstElement * | gst_bin_get_by_name_recurse_up ()
GstElement * | gst_bin_get_by_interface ()
GstIterator * | gst_bin_iterate_elements ()
GstIterator * | gst_bin_iterate_recurse ()
GstIterator * | gst_bin_iterate_sinks ()
GstIterator * | gst_bin_iterate_sorted ()
GstIterator * | gst_bin_iterate_sources ()
GstIterator * | gst_bin_iterate_all_by_interface ()
gboolean | gst_bin_recalculate_latency ()
void | gst_bin_add_many ()
void | gst_bin_remove_many ()
GstPad * | gst_bin_find_unlinked_pad ()
gboolean | gst_bin_sync_children_states ()
#define | GST_BIN_IS_NO_RESYNC()
#define | GST_BIN_CHILDREN()
#define | GST_BIN_CHILDREN_COOKIE()
#define | GST_BIN_NUMCHILDREN()

## Properties

gboolean | async-handling | Read / Write
gboolean | message-forward | Read / Write

## Signals

void | deep-element-added | Run First
void | deep-element-removed | Run First
gboolean | do-latency | Run Last
void | element-added | Run First
void | element-removed | Run First

## Types and Values

struct | GstBin
struct | GstBinClass
enum | GstBinFlags

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GstObject
                ╰── GstElement
                    ╰── GstBin
                        ╰── GstPipeline

## Implemented Interfaces

GstBin implements GstChildProxy.

## Includes

    #include <gst/gst.h>

## Description

GstBin is an element that can contain other GstElement, allowing them to be managed as a group. Pads from the child elements can be ghosted to the bin, see GstGhostPad. This makes the bin look like any other elements and enables creation of higher-level abstraction elements.

A new GstBin is created with `gst_bin_new()`. Use a GstPipeline instead if you want to create a toplevel bin because a normal bin doesn't have a bus or handle clock distribution of its own.

After the bin has been created you will typically add elements to it with `gst_bin_add()`. You can remove elements with `gst_bin_remove()`.

An element can be retrieved from a bin with `gst_bin_get_by_name()`, using the elements name. `gst_bin_get_by_name_recurse_up()` is mainly used for internal purposes and will query the parent bins when the element is not found in the current bin.

An iterator of elements in a bin can be retrieved with `gst_bin_iterate_elements()`. Various other iterators exist to retrieve the elements in a bin.

gst_object_unref() is used to drop your reference to the bin.

The “element-added” signal is fired whenever a new element is added to the bin. Likewise the “element-removed” signal is fired whenever an element is removed from the bin.

### Notes

A GstBin internally intercepts every GstMessage posted by its children and implements the following default behaviour for each of them:

GST_MESSAGE_EOS | This message is only posted by sinks in the PLAYING state. If all sinks posted the EOS message, this bin will post and EOS message upwards.
GST_MESSAGE_SEGMENT_START | just collected and never forwarded upwards. The messages are used to decide when all elements have completed playback of their segment.
GST_MESSAGE_SEGMENT_DONE | Is posted by GstBin when all elements that posted a SEGMENT_START have posted a SEGMENT_DONE.
GST_MESSAGE_DURATION_CHANGED | Is posted by an element that detected a change in the stream duration. The default bin behaviour is to clear any cached duration values so that the next duration query will perform a full duration recalculation. The duration change is posted to the application so that it can refetch the new duration with a duration query. Note that these messages can be posted before the bin is prerolled, in which case the duration query might fail.
GST_MESSAGE_CLOCK_LOST | This message is posted by an element when it can no longer provide a clock. The default bin behaviour is to check if the lost clock was the one provided by the bin. If so and the bin is currently in the PLAYING state, the message is forwarded to the bin parent. This message is also generated when a clock provider is removed from the bin. If this message is received by the application, it should PAUSE the pipeline and set it back to PLAYING to force a new clock distribution.
GST_MESSAGE_CLOCK_PROVIDE | This message is generated when an element can provide a clock. This mostly happens when a new clock provider is added to the bin. The default behaviour of the bin is to mark the currently selected clock as dirty, which will perform a clock recalculation the next time the bin is asked to provide a clock. This message is never sent tot the application but is forwarded to the parent of the bin.
OTHERS | posted upwards.

A GstBin implements the following default behaviour for answering to a GstQuery:

GST_QUERY_DURATION | If the query has been asked before with the same format and the bin is a toplevel bin (ie. has no parent), use the cached previous value. If no previous value was cached, the query is sent to all sink elements in the bin and the MAXIMUM of all values is returned. If the bin is a toplevel bin the value is cached. If no sinks are available in the bin, the query fails.
GST_QUERY_POSITION | The query is sent to all sink elements in the bin and the MAXIMUM of all values is returned. If no sinks are available in the bin, the query fails.
OTHERS | the query is forwarded to all sink elements, the result of the first sink that answers the query successfully is returned. If no sink is in the bin, the query fails.

A GstBin will by default forward any event sent to it to all sink elements. If all the sinks return `TRUE`, the bin will also return `TRUE`, else `FALSE` is returned. If no sinks are in the bin, the event handler will return `TRUE`.

## Functions

### gst_bin_new ()

    GstElement *
    gst_bin_new (const gchar *name);

Creates a new bin with the given name.

#### Parameters

name | the name of the new bin. | [allow-none]

#### Returns

a new GstBin.

[transfer floating]

### gst_bin_add ()

    gboolean
    gst_bin_add (GstBin *bin,
                 GstElement *element);

Adds the given element to the bin. Sets the element's parent, and thus takes ownership of the element. An element can only be added to one bin.

If the element's pads are linked to other pads, the pads will be unlinked before the element is added to the bin.

When you add an element to an already-running pipeline, you will have to take care to set the state of the newly-added element to the desired state (usually PLAYING or PAUSED, same you set the pipeline to originally) with `gst_element_set_state()`, or use `gst_element_sync_state_with_parent()`. The bin or pipeline will not take care of this for you.

MT safe.

#### Parameters

bin | a GstBin |
element | the GstElement to add. | [transfer full]

#### Returns

`TRUE` if the element could be added, `FALSE` if the bin does not want to accept the element.

### gst_bin_remove ()

    gboolean
    gst_bin_remove (GstBin *bin,
                    GstElement *element);

Removes the element from the bin, unparenting it as well. Unparenting the element means that the element will be dereferenced, so if the bin holds the only reference to the element, the element will be freed in the process of removing it from the bin. If you want the element to still exist after removing, you need to call `gst_object_ref()` before removing it from the bin.

If the element's pads are linked to other pads, the pads will be unlinked before the element is removed from the bin.

MT safe.

#### Parameters

bin | a GstBin |
element | the GstElement to remove. | [transfer none]

#### Returns

`TRUE` if the element could be removed, `FALSE` if the bin does not want to remove the element.

### gst_bin_get_by_name ()

    GstElement *
    gst_bin_get_by_name (GstBin *bin,
                         const gchar *name);

Gets the element with the given name from a bin. This function recurses into child bins.

Returns `NULL` if no element with the given name is found in the bin.

MT safe. Caller owns returned reference.

#### Parameters

bin | a GstBin |
name | the element name to search for |

#### Returns

the GstElement with the given name, or `NULL`.

[transfer full][nullable]

### gst_bin_get_by_name_recurse_up ()

    GstElement *
    gst_bin_get_by_name_recurse_up (GstBin *bin,
                                    const gchar *name);

Gets the element with the given name from this bin. If the element is not found, a recursion is performed on the parent bin.

Returns `NULL` if:

- no element with the given name is found in the bin

MT safe. Caller owns returned reference.

#### Parameters

bin | a GstBin |
name | the element name to search for |

#### Returns

the GstElement with the given name, or `NULL`.

[transfer full][nullable]

### gst_bin_get_by_interface ()

    GstElement *
    gst_bin_get_by_interface (GstBin *bin,
                              GType iface);

Looks for an element inside the bin that implements the given interface. If such an element is found, it returns the element. You can cast this element to the given interface afterwards. If you want all elements that implement the interface, use `gst_bin_iterate_all_by_interface()`. This function recurses into child bins.

MT safe. Caller owns returned reference.

#### Parameters

bin | a GstBin |
iface | the GType of an interface |

#### Returns

A GstElement inside the bin implementing the interface.

[transfer full]

### gst_bin_iterate_elements ()

    GstIterator *
    gst_bin_iterate_elements (GstBin *bin);

Gets an iterator for the elements in this bin.

MT safe. Caller owns returned value.

#### Parameters

bin | a GstBin |

#### Returns

a GstIterator of GstElement, or `NULL`.

[transfer full][nullable]

### gst_bin_iterate_recurse ()

    GstIterator *
    gst_bin_iterate_recurse (GstBin *bin);

Gets an iterator for the elements in this bin. This iterator recurses into GstBin children.

MT safe. Caller owns returned value.

#### Parameters

bin | a GstBin |

#### Returns

a GstIterator of GstElement, or `NULL`.

[transfer full][nullable]

### gst_bin_iterate_sinks ()

    GstIterator *
    gst_bin_iterate_sinks (GstBin *bin);

Gets an iterator for all elements in the bin that have the GST_ELEMENT_FLAG_SINK flag set.

MT safe. Caller owns returned value.

#### Parameters

bin | a GstBin |

#### Returns

a GstIterator of GstElement, or `NULL`.

[transfer full][nullable]

### gst_bin_iterate_sorted ()

    GstIterator *
    gst_bin_iterate_sorted (GstBin *bin);

Gets an iterator for the elements in this bin in topologically sorted order. This means that the elements are returned from the most downstream elements (sinks) to the sources.

This function is used internally to perform the state changes of the bin elements and for clock selection.

MT safe. Caller owns returned value.

#### Parameters

bin | a GstBin |

#### Returns

a GstIterator of GstElement, or `NULL`.

[transfer full][nullable]

### gst_bin_iterate_sources ()

    GstIterator *
    gst_bin_iterate_sources (GstBin *bin);

Gets an iterator for all elements in the bin that have the GST_ELEMENT_FLAG_SOURCE flag set.

MT safe. Caller owns returned value.

#### Parameters

bin | a GstBin |

#### Returns

a GstIterator of GstElement, or `NULL`.

[transfer full][nullable]

### gst_bin_iterate_all_by_interface ()

    GstIterator *
    gst_bin_iterate_all_by_interface (GstBin *bin,
                                      GType iface);

Looks for all elements inside the bin that implements the given interface. You can safely cast all returned elements to the given interface. The function recurses inside child bins. The iterator will yield a series of GstElement that should be unreffed after use.

MT safe. Caller owns returned value.

#### Parameters

bin | a GstBin |
iface | the GType of an interface |

#### Returns

a GstIterator of GstElement for all elements in the bin implementing the given interface, or `NULL`.

[transfer full][nullable]

### gst_bin_recalculate_latency ()

    gboolean
    gst_bin_recalculate_latency (GstBin *bin);

Query `bin` for the current latency using and reconfigures this latency to all the elements with a LATENCY event.

This method is typically called on the pipeline when a GST_MESSAGE_LATENCY is posted on the bus.

This function simply emits the 'do-latency' signal so any custom latency calculations will be performed.

#### Parameters

bin | a GstBin |

#### Returns

`TRUE` if the latency could be queried and reconfigured.

### gst_bin_add_many ()

    void
    gst_bin_add_many (GstBin *bin,
                      GstElement *element_1,
                      ...);

Adds a `NULL`-terminated list of elements to a bin. This function is equivalent to calling `gst_bin_add()` for each member of the list. The return value of each `gst_bin_add()` is ignored.

#### Parameters

bin | a GstBin |
element_1 | the GstElement element to add to the bin. | [transfer full]
... | additional elements to add to the bin. | [transfer full]

### gst_bin_remove_many ()

    void
    gst_bin_remove_many (GstBin *bin,
                         GstElement *element_1,
                         ...);

Remove a list of elements from a bin. This function is equivalent to calling `gst_bin_remove()` with each member of the list.

#### Parameters

bin | a GstBin |
element_1 | the first GstElement to remove from the bin. | [transfer none]
... | `NULL`-terminated list of elements to remove from the bin. | [transfer none]

### gst_bin_find_unlinked_pad ()

    GstPad *
    gst_bin_find_unlinked_pad (GstBin *bin,
                               GstPadDirection direction);

Recursively looks for elements with an unlinked pad of the given direction within the specified bin and returns an unlinked pad if one is found, or `NULL` otherwise. If a pad is found, the caller owns a reference to it and should use `gst_object_unref()` on the pad when it is not needed any longer.

#### Parameters

bin | bin in which to look for elements with unlinked pads |
direction | whether to look for an unlinked source or sink pad |

#### Returns

unlinked pad of the given direction, `NULL`.

[transfer full][nullable]

### gst_bin_sync_children_states ()

    gboolean
    gst_bin_sync_children_states (GstBin *bin);

Synchronizes the state of every child of `bin` with the state of `bin` . See also `gst_element_sync_state_with_parent()`.

#### Parameters

bin | a GstBin |

#### Returns

`TRUE` if syncing the state was successful for all children, otherwise `FALSE`.

Since: 1.6

### GST_BIN_IS_NO_RESYNC()

    #define GST_BIN_IS_NO_RESYNC(bin)        (GST_OBJECT_FLAG_IS_SET(bin,GST_BIN_FLAG_NO_RESYNC))

Check if `bin` will resync its state change when elements are added and removed.

#### Parameters

bin | A GstBin |

Since: 1.0.5

### GST_BIN_CHILDREN()

    #define GST_BIN_CHILDREN(bin)		(GST_BIN_CAST(bin)->children)

Gets the list with children in a bin.

#### Parameters

bin | a GstBin |

### GST_BIN_CHILDREN_COOKIE()

    #define GST_BIN_CHILDREN_COOKIE(bin) (GST_BIN_CAST(bin)->children_cookie)

Gets the children cookie that watches the children list.

#### Parameters

bin | a GstBin |

### GST_BIN_NUMCHILDREN()

    #define GST_BIN_NUMCHILDREN(bin) (GST_BIN_CAST(bin)->numchildren)

Gets the number of children in a bin.

#### Parameters

bin | a GstBin |

## Types and Values

### struct GstBin

    struct GstBin {
      /* our children, subclass are supposed to update these
       * fields to reflect their state with _iterate_*() */
      gint		 numchildren;
      GList		*children;
      guint32	 children_cookie;

      GstBus        *child_bus;
      GList         *messages;

      gboolean	 polling;
      gboolean       state_dirty;

      gboolean       clock_dirty;
      GstClock *provided_clock;
      GstElement    *clock_provider;
    };

The GstBin base class. Subclasses can access these fields provided the LOCK is taken.

#### Members

gint `numchildren`; | the number of children in this bin |
GList *`children`; | the list of children in this bin. | [element-type Gst.Element]
guint32 `children_cookie`; | updated whenever `children` changes |
GstBus *`child_bus`; | internal bus for handling child messages |
GList *`messages`; | queued and cached messages. | [element-type Gst.Message]
gboolean `polling`; | the bin is currently calculating its state |
gboolean `state_dirty`; | the bin needs to recalculate its state (deprecated) |
gboolean `clock_dirty`; | the bin needs to select a new clock |
GstClock *`provided_clock`; | the last clock selected |
GstElement *`clock_provider`; | the element that provided `provided_clock` |

### struct GstBinClass

    struct GstBinClass {
      GstElementClass parent_class;

      /* virtual methods for subclasses */
      gboolean (*add_element)		(GstBin *bin, GstElement *element);
      gboolean (*remove_element) (GstBin *bin, GstElement *element);

      void		(*handle_message) (GstBin *bin, GstMessage *message);

      /* signal */
      void          (*deep_element_added)   (GstBin *bin, GstBin *sub_bin, GstElement *child);
      void          (*deep_element_removed) (GstBin *bin, GstBin *sub_bin, GstElement *child);
    };

Subclasses can override the `add_element` and `remove_element` to update the list of children in the bin.

The `handle_message` method can be overridden to implement custom message handling. `handle_message` takes ownership of the message, just like gst_element_post_message.

The `element_added_deep` vfunc will be called when a new element has been added to any bin inside this bin, so it will also be called if a new child was added to a sub-bin of this bin. GstBin implementations that override this message should chain up to the parent class implementation so the element-added-deep signal is emitted on all parents.

#### Members

`add_element` () | method to add an element to a bin |
`remove_element` () | method to remove an element from a bin |
`handle_message` () | method to handle a message from the children |
`deep_element_added` () |  |
`deep_element_removed` () |  |

### enum GstBinFlags

GstBinFlags are a set of flags specific to bins. Most are set/used internally. They can be checked using the `GST_OBJECT_FLAG_IS_SET()` macro, and (un)set using `GST_OBJECT_FLAG_SET()` and `GST_OBJECT_FLAG_UNSET()`.

#### Members

GST_BIN_FLAG_NO_RESYNC | don't resync a state change when elements are added or linked in the bin (Since 1.0.5) |
GST_BIN_FLAG_LAST | the last enum in the series of flags for bins. Derived classes can use this as first value in a list of flags. |

## Property Details

### The `“async-handling”` property

      “async-handling”           gboolean

If set to `TRUE`, the bin will handle asynchronous state changes. This should be used only if the bin subclass is modifying the state of its children on its own.

Flags: Read / Write

Default value: FALSE

### The `“message-forward”` property

      “message-forward”          gboolean

Forward all children messages, even those that would normally be filtered by the bin. This can be interesting when one wants to be notified of the EOS state of individual elements, for example.

The messages are converted to an ELEMENT message with the bin as the source. The structure of the message is named 'GstBinForwarded' and contains a field named 'message' of type GST_TYPE_MESSAGE that contains the original forwarded message.

Flags: Read / Write

Default value: FALSE

## Signal Details

### The `“deep-element-added”` signal

    void
    user_function (GstBin     *bin,
                   GstBin     *sub_bin,
                   GstElement *element,
                   gpointer    user_data)

Will be emitted after the element was added to sub_bin.

#### Parameters

bin | the GstBin |
sub_bin | the GstBin the element was added to |
element | the GstElement that was added to `sub_bin` |
user_data | user data set when the signal handler was connected. |

Flags: Run First

Since: 1.10

### The `“deep-element-removed”` signal

    void
    user_function (GstBin     *bin,
                   GstBin     *sub_bin,
                   GstElement *element,
                   gpointer    user_data)

Will be emitted after the element was removed from sub_bin.

#### Parameters

bin | the GstBin |
sub_bin | the GstBin the element was removed from |
element | the GstElement that was removed from `sub_bin` |
user_data | user data set when the signal handler was connected. |

Flags: Run First

Since: 1.10

### The `“do-latency”` signal

    gboolean
    user_function (GstBin  *bin,
                   gpointer user_data)

Will be emitted when the bin needs to perform latency calculations. This signal is only emitted for toplevel bins or when async-handling is enabled.

Only one signal handler is invoked. If no signals are connected, the default handler is invoked, which will query and distribute the lowest possible latency to all sinks.

Connect to this signal if the default latency calculations are not sufficient, like when you need different latencies for different sinks in the same pipeline.

#### Parameters

bin | the GstBin |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“element-added”` signal

    void
    user_function (GstBin     *bin,
                   GstElement *element,
                   gpointer    user_data)

Will be emitted after the element was added to the bin.

#### Parameters

bin | the GstBin |
element | the GstElement that was added to the bin |
user_data | user data set when the signal handler was connected. |

Flags: Run First

### The `“element-removed”` signal

    void
    user_function (GstBin     *bin,
                   GstElement *element,
                   gpointer    user_data)

Will be emitted after the element was removed from the bin.

#### Parameters

bin | the GstBin |
element | the GstElement that was removed from the bin |
user_data | user data set when the signal handler was connected. |

Flags: Run First